// File: SocketServer.java
// TCP/IP threaded Java server example

import java.io.*;
import java.net.*;
import javax.swing.*;

class ClientWorker implements Runnable {
  private Socket client;

  // Constructor
  ClientWorker(Socket client) {
   this.client = client;
  }

  public void run(){
    String line;
    BufferedReader in = null;
    PrintWriter out = null;
    // Set up streams
    try{
      System.out.println("Server: Before in");
      in = new BufferedReader(new InputStreamReader(client.getInputStream()));
      System.out.println("Server: Interior");
      Thread.sleep(1000);  		// sleep 1 second
      out = new PrintWriter(client.getOutputStream(), true);
      System.out.println("Server: OUT");
    } 
    catch (IOException e) {
      System.out.println("in or out failed");
      System.exit(-1);
    }
    catch (Exception e) {
      System.out.println("Server: Couldn't sleep!");
    }
    // Communications
    while(true){
      	try{
      	 Thread.sleep(1); 	// keep race conditions out
         line = in.readLine();
//         System.out.println("Got "+line+" from user");
	 //Send data back to client
         out.println(line);
      	} 
	catch (IOException e) {
         System.out.println("Read failed");
         System.exit(-1);
       	}
        catch (Exception e) {
	  System.out.println("Server: Couldn't sleep!");
        }
    }
  }
}

public class SocketThrdServer
{
   ServerSocket server = null;
   int port;
   
   public SocketThrdServer()
   { server=null;
     port=0;
   }

   public void listenSocket()
   {// First, get a socket; use the port passed in
    int port=0;
    try {
        port = 
	  Integer.parseInt(JOptionPane.showInputDialog("Enter Port Number"));
    }
    catch (Exception e) {
      JOptionPane.
      	showMessageDialog(null, "alert", "alert", JOptionPane.ERROR_MESSAGE);	  
      System.exit(-1);
    }  	    
    try{
      server = new ServerSocket(port); 
    } 
    catch (IOException e) {
      System.out.println("Could not listen on port "+port);
      System.exit(-1);
    }
    // Handle service requests
    while(true){
      ClientWorker w;
      try{
	// accept() fires when a request comes in; blocks until then
     	Socket client=server.accept();
        w = new ClientWorker(client);
	System.out.println("Accepted....");
	// Set up a thread to handle this client's requests
        Thread t = new Thread(w);
	// execute the thread's run() method;
        t.start();    
	// then, back to wait for another client's request
      	Thread.sleep(2500);  		// sleep 2.5 seconds
      } 
      catch (IOException e) {
        System.out.println("Accept failed: Port #"+port);
        System.exit(-1);
      }
      catch (Exception e) {
	  System.out.println("Server: Couldn't sleep!");
      }
    }
  }

  protected void finalize(){
  //Objects created in run method are finalized when 
  //program terminates and thread exits
     try{
        server.close();
    } 
    catch (IOException e) {
        System.out.println("Could not close socket");
        System.exit(-1);
    }
  }

  public static void main(String[] args){
        SocketThrdServer frame = new SocketThrdServer();
	// Ready; let it begin being a server
        frame.listenSocket();
  }
}

